#//-----------------------------------------------
#//TUSB-S01SWx用Pythonサンプルプログラム
#//
#//2024_03_18　株式会社タートル工業
#//Copyright (C) 2024 Turtle Industry Co.,Ltd.
#//-----------------------------------------------

#TUSB-S01SW操作用コード
import tusbs01sw

import tkinter as tk
import threading
from tkinter import messagebox

#/// Functions ////////////////////////////////
def ShowInfo(str):
    messagebox.showinfo("",str)

def RelOn_on():
    retv = tusbs01sw.Tusbs01sw_Out(0,1)
    if( retv != 0 ):
        ShowInfo("error -> " + retv)

def RelOff_on():
    retv = tusbs01sw.Tusbs01sw_Out(0,0)
    if( retv != 0 ):
        ShowInfo("error -> " + retv)

def GetErrStr(errcode):
    return tusbs01sw.GetErrMessage(errcode)

#//////////////////////////////////////////////

#/// form generator ///////////////////////////
form = tk.Tk()
form.geometry('308x215')
form.title('TUSB-S01SWx Sample')

RelOnBtn = tk.Button(form, text = 'RelayOn', command=RelOn_on)
RelOnBtn.place(relwidth =0.4,relheight=0.2,relx=0.25,rely=0.8,anchor=tk.CENTER)

RelOffBtn = tk.Button(form, text = 'RelayOff', command=RelOff_on)
RelOffBtn.place(relwidth =0.4,relheight=0.2,relx=0.75,rely=0.8,anchor=tk.CENTER)

InfoLbl = tk.Label(form, text = "各ボタンを押下するとリレーがOnOffします。")
InfoLbl.place(relx=0.1,rely=0.2)

LedStatus = tk.Label(form,text="Coil")
LedStatus.place(relx=0.45,rely = 0.4,anchor=tk.E)

#/////////////////////////////////////////////////

#/// Shape ////////////////////////////////////

ledsim = tk.Canvas(form,width = 10, height = 10, bg = "red")
ledsim.place(relx = 0.5,rely = 0.4,anchor = tk.CENTER)

#/// interval timer ///////////////////////////
timebreak = False
def intervalTimer():
    if(timebreak == False):
        retv,OnOff = tusbs01sw.Tusbs01sw_In(0)
        if( retv != 0 ):
            return
        if(OnOff == 0) :
            ledsim['bg'] = "#800000000" #Dark Red
        else:
            ledsim['bg'] = "#FFF000000" #Red
        threading.Timer(0.1,intervalTimer).start()
#/////////////////////////////////////////////////

#/// Start 
retval = tusbs01sw.Tusbs01sw_Device_Open(0)

if( retval == 0 ):
    intervalTimer()
    form.mainloop()
    timebreak = True
    tusbs01sw.Tusbs01sw_Device_Close(0)
else:
    messagebox.showinfo(message=GetErrStr(retval))



